(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var check = Package.check.check;
var Match = Package.check.Match;
var Accounts = Package['accounts-base'].Accounts;

/* Package-scope variables */
var AccountsUi, SandstormAccountSettingsUi;

(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                 //
// packages/sandstorm-accounts-ui/accounts-ui-server.js                                            //
//                                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                   //
// Sandstorm - Personal Cloud Sandbox                                                              // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                           // 2
// All rights reserved.                                                                            // 3
//                                                                                                 // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                 // 5
// you may not use this file except in compliance with the License.                                // 6
// You may obtain a copy of the License at                                                         // 7
//                                                                                                 // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                    // 9
//                                                                                                 // 10
// Unless required by applicable law or agreed to in writing, software                             // 11
// distributed under the License is distributed on an "AS IS" BASIS,                               // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                        // 13
// See the License for the specific language governing permissions and                             // 14
// limitations under the License.                                                                  // 15
                                                                                                   // 16
// Meteor permits users to modify their own profile by default, for some reason.                   // 17
Meteor.users.deny({                                                                                // 18
  insert: function () { return true; },                                                            // 19
  update: function () { return true; },                                                            // 20
  remove: function () { return true; },                                                            // 21
  fetch: []                                                                                        // 22
});                                                                                                // 23
                                                                                                   // 24
Meteor.publish("getMyUsage", function () {                                                         // 25
  if (this.userId) {                                                                               // 26
    // TODO(someday): Make this reactive.                                                          // 27
    var usage = this.connection.sandstormDb.getMyUsage(Meteor.users.findOne(this.userId));         // 28
    this.added("users", this.userId, {pseudoUsage: usage});                                        // 29
  }                                                                                                // 30
  this.ready();                                                                                    // 31
});                                                                                                // 32
                                                                                                   // 33
/////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                 //
// packages/sandstorm-accounts-ui/accounts-ui-methods.js                                           //
//                                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                   //
// Sandstorm - Personal Cloud Sandbox                                                              // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                           // 2
// All rights reserved.                                                                            // 3
//                                                                                                 // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                 // 5
// you may not use this file except in compliance with the License.                                // 6
// You may obtain a copy of the License at                                                         // 7
//                                                                                                 // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                    // 9
//                                                                                                 // 10
// Unless required by applicable law or agreed to in writing, software                             // 11
// distributed under the License is distributed on an "AS IS" BASIS,                               // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                        // 13
// See the License for the specific language governing permissions and                             // 14
// limitations under the License.                                                                  // 15
                                                                                                   // 16
// This file contains method definitions which are available on both client and server (on the     // 17
// client for prediction purposes, on the server for actual execution).                            // 18
                                                                                                   // 19
var ValidHandle = Match.Where(function (handle) {                                                  // 20
  check(handle, String);                                                                           // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                     // 22
});                                                                                                // 23
                                                                                                   // 24
Meteor.methods({                                                                                   // 25
  updateProfile: function (profile) {                                                              // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                            // 27
    check(profile, {                                                                               // 28
      id: String,                                                                                  // 29
      name: String,                                                                                // 30
      handle: ValidHandle,                                                                         // 31
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                  // 32
      unverifiedEmail: Match.Optional(String)                                                      // 33
    });                                                                                            // 34
                                                                                                   // 35
    if (!this.userId) {                                                                            // 36
      throw new Meteor.Error(403, "not logged in");                                                // 37
    }                                                                                              // 38
                                                                                                   // 39
    var newValues = {                                                                              // 40
      "identities.$.profile.name": profile.name,                                                   // 41
      "identities.$.profile.handle": profile.handle,                                               // 42
      "identities.$.profile.pronoun": profile.pronoun,                                             // 43
      "hasCompletedSignup": true                                                                   // 44
    };                                                                                             // 45
                                                                                                   // 46
    if (profile.unverifiedEmail) {                                                                 // 47
      newValues["identities.$.unverifiedEmail"] = profile.unverifiedEmail                          // 48
    }                                                                                              // 49
                                                                                                   // 50
    Meteor.users.update({_id: this.userId, "identities.id": profile.id}, {$set: newValues});       // 51
  },                                                                                               // 52
                                                                                                   // 53
  testFirstSignup: function (profile) {                                                            // 54
    if (!this.userId) {                                                                            // 55
      throw new Meteor.Error(403, "not logged in");                                                // 56
    }                                                                                              // 57
                                                                                                   // 58
    Meteor.users.update(this.userId, {$unset: {hasCompletedSignup: ""}});                          // 59
  }                                                                                                // 60
});                                                                                                // 61
                                                                                                   // 62
if (Meteor.isClient) {                                                                             // 63
  window.testFirstSignup = function () {                                                           // 64
    Meteor.call("testFirstSignup");                                                                // 65
  }                                                                                                // 66
}                                                                                                  // 67
                                                                                                   // 68
if (Meteor.isServer) {                                                                             // 69
  // Methods that can't be simulated.                                                              // 70
                                                                                                   // 71
  Meteor.methods({                                                                                 // 72
    uploadProfilePicture: function (identityId) {                                                  // 73
      check(identityId, String);                                                                   // 74
      if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) { // 75
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);         // 76
      }                                                                                            // 77
                                                                                                   // 78
      return this.connection.sandstormDb.newAssetUpload({                                          // 79
        profilePicture: { userId: this.userId, identityId: identityId }                            // 80
      });                                                                                          // 81
    },                                                                                             // 82
                                                                                                   // 83
    cancelUploadProfilePicture: function (id) {                                                    // 84
      check(id, String);                                                                           // 85
      this.connection.sandstormDb.fulfillAssetUpload(id);                                          // 86
    },                                                                                             // 87
  });                                                                                              // 88
}                                                                                                  // 89
                                                                                                   // 90
/////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-accounts-ui'] = {
  AccountsUi: AccountsUi,
  SandstormAccountSettingsUi: SandstormAccountSettingsUi
};

})();

//# sourceMappingURL=sandstorm-accounts-ui.js.map
